<template>
    <app-layout>
        <div class="row justify-content-center">
            <div class="col-lg-6">
                <h1 class="h2 mb-3">{{ skin.name }}</h1>
                
                <form @submit.prevent="form.patch(route('server.skins.skinUpdate', skin))">
                    <form-field text="Name" id="inputName" :errors="form.errors.name" v-slot="slotProps">
                        <form-input v-model="form.name" v-bind="slotProps" />
                    </form-field>
                    
                    <form-field text="Head ID" id="inputHeadID" :errors="form.errors.head_id" v-slot="slotProps">
                        <form-input v-model="form.head_id" v-bind="slotProps" />
                    </form-field>
                    
                    <form-field text="Body ID" id="inputBodyID" :errors="form.errors.body_id" v-slot="slotProps">
                        <form-input v-model="form.body_id" v-bind="slotProps" />
                    </form-field>
                    
                    <form-field text="Foot ID" id="inputFootID" :errors="form.errors.foot_id" v-slot="slotProps">
                        <form-input v-model="form.foot_id" v-bind="slotProps" />
                    </form-field>
                    
                    <form-field text="Hand ID" id="inputHandID" :errors="form.errors.hand_id" v-slot="slotProps">
                        <form-input v-model="form.hand_id" v-bind="slotProps" />
                    </form-field>
                    
                    <form-checkbox-field text="Special Permissions">
                        <form-checkbox id="inputVotableAdmin" v-model="form.usable_by_admins">Admins</form-checkbox>
                        <form-checkbox id="inputVotablePlayer" v-model="form.usable_by_all">All Players <span class="form-text">(Including Admins)</span></form-checkbox>
                    </form-checkbox-field>
                    
                    <form-list-input text="Groups" :list="this.form.groups" :errors="form.errors" errorPrefix="groups" :readonly="true" :default="selectedGroup" displayKey="name">
                        <select class="form-select" v-model="selectedGroup">
                            <option v-for="group in availableGroups" :key="group.id" :value="group">{{ group.name }}</option>
                        </select>
                    </form-list-input>
                    
                    <form-button :disabled="form.processing">Save Changes</form-button>
                    <inertia-link class="btn btn-danger ms-2" as="button" type="button" :href="route('server.skins.skinDelete', skin)" method="delete">Delete Skin</inertia-link>
                </form>
            </div>
        </div>
    </app-layout>
</template>

<script>
    import { useForm } from '@inertiajs/inertia-vue3'
    import AppLayout from '@/Layouts/AppLayout'
    import FormInput from '@/Components/Form/FormInput'
    import FormField from '@/Components/Form/FormField'
    import FormButton from '@/Components/Form/FormButton'
    import FormCheckboxField from '@/Components/Form/FormCheckboxField'
    import FormCheckbox from '@/Components/Form/FormCheckbox'
    import FormListInput from '@/Components/Form/FormListInput'
    
    export default {
        props: {
            'skin': Object,
            'skinGroups': Array,
            'availableGroups': Array,
        },
        
        components: {
            AppLayout,
            FormInput,
            FormField,
            FormButton,
            FormCheckboxField,
            FormCheckbox,
            FormListInput
        },
        
        data() {
            return {
                selectedGroup: null,
            }
        },
        
        mounted() {
            this.form.name = this.skin.name;
            this.form.head_id = this.skin.head_id;
            this.form.body_id = this.skin.body_id;
            this.form.foot_id = this.skin.foot_id;
            this.form.hand_id = this.skin.hand_id;
            this.form.usable_by_all = this.skin.usable_by_all;
            this.form.usable_by_admins = this.skin.usable_by_admins;
            
            this.form.groups = this.skinGroups;
        },
        
        setup () {
            const form = useForm({
                name: null,
                head_id: null,
                body_id: null,
                foot_id: null,
                hand_id: null,
                usable_by_all: null,
                usable_by_admins: null,
                groups: [],
            })
            
            return { form }
        },
    }
</script>